api/app/signals/apps/api/urls.py
from django.urls import include, path

from signals.apps.api.generics.views import SwaggerView
from signals.apps.api.v0 import views as v0_views
from signals.apps.api.v0.routers import SignalsRouterVersion0

# API Version 0
signal_router_v0 = SignalsRouterVersion0()
signal_router_v0.register(r'signal/image', v0_views.SignalImageUpdateView, basename='signal-img')
signal_router_v0.register(r'signal', v0_views.SignalViewSet, basename='signal')
signal_router_v0.register(r'auth/signal', v0_views.SignalAuthViewSet, basename='signal-auth')
signal_router_v0.register(r'auth/status', v0_views.StatusAuthViewSet, basename='status-auth')
signal_router_v0.register(r'auth/category', v0_views.CategoryAuthViewSet, basename='category-auth')
signal_router_v0.register(r'auth/location', v0_views.LocationAuthViewSet, basename='location-auth')
signal_router_v0.register(r'auth/priority', v0_views.PriorityAuthViewSet, basename='priority-auth')
signal_router_v0.register(r'auth/note', v0_views.NoteAuthViewSet, basename='note-auth')

signal_router_v0.urls.append(
    path(
        'category/prediction',
        v0_views.MlPredictCategoryView.as_view(),
        name='ml-tool-predict-proxy'
    )
)

urlpatterns = [
    # AP Version 0
    path('', include((signal_router_v0.urls, 'signals'), namespace='v0')),

    # API Version 1
    path('', include(('signals.apps.api.v1.urls', 'signals'), namespace='v1')),

    # Swagger
    path('swagger/openapi.yaml', SwaggerView.as_view()),
]

api/app/signals/apps/api/v1/urls.py
from django.urls import include, path

from signals.apps.api.v1.routers import SignalsRouterVersion1
from signals.apps.api.v1.views import (  # MLPredictCategoryView,  # V1 disabled for now
    ChildCategoryViewSet,
    GeneratePdfView,
    NamespaceView,
    ParentCategoryViewSet,
    PrivateCategoryViewSet,
    PrivateDepartmentViewSet,
    PrivateSignalAttachmentsViewSet,
    PrivateSignalSplitViewSet,
    PrivateSignalViewSet,
    PublicSignalAttachmentsViewSet,
    PublicSignalViewSet,
    SignalCategoryRemovedAfterViewSet,
    StatusMessageTemplatesViewSet,
    StoredSignalFilterViewSet
)
from signals.apps.feedback.views import FeedbackViewSet, StandardAnswerViewSet
from signals.apps.search.views import SearchView
from signals.apps.users.v1.views import PermissionViewSet, RoleViewSet, UserViewSet

# Public API
public_router = SignalsRouterVersion1()
public_router.register(r'public/terms/categories', ParentCategoryViewSet, basename='category')
public_router.register(r'public/signals', PublicSignalViewSet, basename='public-signals')
public_router.register(r'public/feedback/standard_answers', StandardAnswerViewSet, basename='feedback-standard-answers')
public_router.register(r'public/feedback/forms', FeedbackViewSet, basename='feedback-forms')

# Private API
private_router = SignalsRouterVersion1()
private_router.register(r'private/signals', PrivateSignalViewSet, basename='private-signals')
private_router.register(r'private/me/filters', StoredSignalFilterViewSet, basename='stored-signal-filters')
private_router.register(r'private/users', UserViewSet, basename='user')
private_router.register(r'private/roles', RoleViewSet, basename='group')
private_router.register(r'private/permissions', PermissionViewSet, basename='permission')
private_router.register(r'private/departments', PrivateDepartmentViewSet, basename='department')
private_router.register(r'private/categories', PrivateCategoryViewSet, basename='private-category')

# Combined API
base_router = SignalsRouterVersion1()
base_router.registry.extend(public_router.registry)
base_router.registry.extend(private_router.registry)

urlpatterns = [
    # The base routes of the API
    path('v1/', include(base_router.urls)),

    # Used for namespacing SIA, a HAL standard
    path('v1/relations', NamespaceView.as_view(), name='signal-namespace'),

    # Public additions
    # path('v1/public/', include(public_router.urls)),
    path('v1/public/', include([
        path('signals/<str:signal_id>/attachments',
             PublicSignalAttachmentsViewSet.as_view({'post': 'create'}),
             name='public-signals-attachments'),
        path('terms/categories/<str:slug>/sub_categories/<str:sub_slug>',
             ChildCategoryViewSet.as_view({'get': 'retrieve'}),
             name='category-detail'),

        # V1 disabled for now
        # path('category/prediction', MLPredictCategoryView.as_view({'get': 'retrieve'}), name='ml-predict-category'),
    ])),

    # Private additions
    path('v1/private/', include([
        # Returns the details of the currently logged in user
        path('me/', UserViewSet.as_view({'get': 'me'}), name='auth-me'),

        # Get/Replace the status message templates per category
        path('terms/categories/<str:slug>/status-message-templates',
             StatusMessageTemplatesViewSet.as_view({'get': 'retrieve', 'post': 'create'}),
             name='private-status-message-templates-parent'),
        path('terms/categories/<str:slug>/sub_categories/<str:sub_slug>/status-message-templates',
             StatusMessageTemplatesViewSet.as_view({'get': 'retrieve', 'post': 'create'}),
             name='private-status-message-templates-child'),

        # Additional Signals endpoints
        path('signals/<int:pk>/split',
             PrivateSignalSplitViewSet.as_view({'get': 'retrieve', 'post': 'create'}),
             name='private-signals-split'),
        path('signals/<int:pk>/attachments',
             PrivateSignalAttachmentsViewSet.as_view({'get': 'list', 'post': 'create'}),
             name='private-signals-attachments'),
        path('signals/<int:pk>/pdf', GeneratePdfView.as_view(), name='signal-pdf-download'),
        path('signals/category/removed',
             SignalCategoryRemovedAfterViewSet.as_view({'get': 'list'}),
             name='signal-category-changed-since'),

        # Search
        path('search', SearchView.as_view({'get': 'list'}), name='elastic-search')
    ])),
]

api/app/signals/urls.py
from django.conf import settings
from django.contrib import admin
from django.urls import include, path

from signals.apps.users.v0.views import UserMeView

urlpatterns = [
    path('status/', include('signals.apps.health.urls')),

    # The Signals application is routed behind the HAproxy with `/signals/` as path.
    path('signals/', include('signals.apps.api.urls')),
    path('signals/admin/', admin.site.urls),

    # DEPRECATED url route for `auth/me`. Should be fixed in the frontend before we can remove
    # this endpoint here.
    path('signals/auth/me/', UserMeView.as_view()),
    path('signals/user/auth/me/', UserMeView.as_view()),

    # SOAP stand-in endpoints
    path('signals/sigmax/', include('signals.apps.sigmax.urls')),

    # path('signals/experimental/reporting/', include('signals.apps.reporting.urls'))
]

if settings.DEBUG:
    import debug_toolbar
    from django.conf.urls.static import static

    media_root = static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
    urlpatterns = [
        path('__debug__/', include(debug_toolbar.urls)),
    ] + urlpatterns + media_root

api/app/signals/apps/signals/models/signal.py
import uuid

from django.conf import settings
from django.contrib.gis.db import models
from django.contrib.postgres.fields import ArrayField, JSONField
from django.contrib.sites.models import Site
from django.core.exceptions import ValidationError
from django.utils import timezone
from pytz import utc
from swift.storage import SwiftStorage

from signals.apps.signals import workflow
from signals.apps.signals.managers import SignalManager
from signals.apps.signals.models.mixins import CreatedUpdatedModel
from signals.apps.signals.querysets import SignalQuerySet


class Signal(CreatedUpdatedModel):
    SOURCE_DEFAULT_ANONYMOUS_USER = 'online'

    # we need an unique id for external systems.
    # TODO SIG-563 rename `signal_id` to `signal_uuid` to be more specific.
    signal_id = models.UUIDField(default=uuid.uuid4, db_index=True)
    source = models.CharField(max_length=128, default=SOURCE_DEFAULT_ANONYMOUS_USER)

    text = models.CharField(max_length=3000)
    text_extra = models.CharField(max_length=10000, default='', blank=True)

    location = models.OneToOneField('signals.Location',
                                    related_name='signal',
                                    null=True,
                                    on_delete=models.SET_NULL)
    status = models.OneToOneField('signals.Status',
                                  related_name='signal',
                                  null=True,
                                  on_delete=models.SET_NULL)
    category_assignment = models.OneToOneField('signals.CategoryAssignment',
                                               related_name='signal',
                                               null=True,
                                               on_delete=models.SET_NULL)
    categories = models.ManyToManyField('signals.Category',
                                        through='signals.CategoryAssignment')
    reporter = models.OneToOneField('signals.Reporter',
                                    related_name='signal',
                                    null=True,
                                    on_delete=models.SET_NULL)
    priority = models.OneToOneField('signals.Priority',
                                    related_name='signal',
                                    null=True,
                                    on_delete=models.SET_NULL)

    # Date of the incident.
    incident_date_start = models.DateTimeField(null=False)
    incident_date_end = models.DateTimeField(null=True)

    # Date action is expected
    operational_date = models.DateTimeField(null=True)

    # Date we should have reported back to reporter.
    expire_date = models.DateTimeField(null=True)

    # file will be saved to MEDIA_ROOT/uploads/2015/01/30
    upload = ArrayField(models.FileField(upload_to='uploads/%Y/%m/%d/'), null=True)  # TODO: remove

    extra_properties = JSONField(null=True)

    # SIG-884
    parent = models.ForeignKey(to='self', related_name='children', null=True, blank=True,
                               on_delete=models.SET_NULL)

    objects = SignalQuerySet.as_manager()
    actions = SignalManager()

    @property
    def image(self):
        """ Field for backwards compatibility. The attachment table replaces the old 'image'
        property """
        attachment = self.attachments.filter(is_image=True).first()
        return attachment.file if attachment else ""

    @property
    def image_crop(self):
        attachment = self.attachments.filter(is_image=True).first()
        return attachment.image_crop if self.image else ''

    class Meta:
        permissions = (
            ('sia_read', 'Can read from SIA'),
            ('sia_write', 'Can write to SIA'),
            ('sia_split', 'Can split a signal into a parent with X children'),
            ('sia_signal_create_initial', 'Can create new signals'),
            ('sia_signal_create_note', 'Can create notes for signals'),
            ('sia_signal_change_status', 'Can change the status of a signal'),
            ('sia_signal_change_category', 'Can change the category of a signal'),
            ('sia_signal_export', 'Can export signals'),
            ('sia_signal_report', 'Can create reports for signals'),
        )
        ordering = ('created_at',)
        indexes = [
            models.Index(fields=['created_at']),
            models.Index(fields=['id', 'parent']),
        ]

    def __init__(self, *args, **kwargs):
        super(Signal, self).__init__(*args, **kwargs)
        if not self.signal_id:
            self.signal_id = uuid.uuid4()

    def __str__(self):
        """Identifying string.
        DO NOT expose sensitive stuff here.
        """

        # Fix for bug SIG-2486 Timezones were not consistently shown
        created_at = self.created_at
        field_timezone = timezone.get_current_timezone() if settings.USE_TZ else None
        if timezone.is_aware(created_at) and field_timezone:
            created_at = created_at.astimezone(field_timezone)
        elif timezone.is_aware(created_at):
            created_at = timezone.make_naive(created_at, utc)

        return f'{self.id} - ' \
               f'{self.status.state if self.status else ""} - ' \
               f'{self.location.buurt_code if self.location else ""} - ' \
               f'{created_at.isoformat()}'

    @property
    def sia_id(self):
        """SIA identifier used for external communication.

        :returns: str
        """
        return 'SIA-{id}'.format(id=self.id)

    def get_fqdn_image_crop_url(self):
        """Get FQDN image crop url.

        :returns: url (str) or None
        """
        if not self.image_crop:
            return None

        is_swift = isinstance(self.image_crop.storage, SwiftStorage)
        if is_swift:
            return self.image_crop.url  # Generated temp url from Swift Object Store.
        else:
            # Generating a fully qualified url ourself.
            current_site = Site.objects.get_current()
            is_local = 'localhost' in current_site.domain or settings.DEBUG
            fqdn_url = '{scheme}://{domain}{path}'.format(
                scheme='http' if is_local else 'https',
                domain=current_site.domain,
                path=self.image_crop.url)
            return fqdn_url

    def is_parent(self):
        # If we have children we are a parent
        return self.children.exists()

    def is_child(self):
        # If we have a parent we are a child
        return self.parent is not None

    @property
    def siblings(self):
        if self.is_child():
            # If we are a child return all siblings
            siblings_qs = self.parent.children.all()
            if self.pk:
                # Exclude myself if possible
                return siblings_qs.exclude(pk=self.pk)
            return siblings_qs

        # Return a non queryset
        return self.__class__.objects.none()

    def _validate(self):
        if self.is_parent() and self.is_child():
            # We cannot be a parent and a child at once
            raise ValidationError('Cannot be a parent and a child at the once')

        if self.parent and self.parent.is_child():
            # The parent of this Signal cannot be a child of another Signal
            raise ValidationError('A child of a child is not allowed')

        if (self.pk is None and self.is_child() and
                self.siblings.count() >= settings.SIGNAL_MAX_NUMBER_OF_CHILDREN):
            # we are a new child and our parent already has the max number of children
            raise ValidationError('Maximum number of children reached for the parent Signal')

        if self.children.exists() and self.status.state != workflow.GESPLITST:
            # If we have children our status can only be "gesplitst"
            raise ValidationError('The status of a parent Signal can only be "gesplitst"')

    def save(self, *args, **kwargs):
        self._validate()
        super(Signal, self).save(*args, **kwargs)

    @property
    def type_assignment(self):
        return self.types.first() if self.types.exists() else None

api/app/signals/apps/api/generics/views.py
import os

from django.views.generic.base import TemplateView


class SwaggerView(TemplateView):
    template_name = 'api/swagger/openapi.yaml'

    def get_context_data(self, **kwargs):
        global_api_root = os.getenv('global_api_root', None)

        context = super().get_context_data(**kwargs)
        context['global_api_root'] = global_api_root
        return context

api/app/signals/apps/api/pdf/views.py
from django.views.generic.base import ContextMixin
from rest_framework.generics import GenericAPIView

from signals.apps.api.pdf.mixins import PDFTemplateResponseMixin


class PDFTemplateView(PDFTemplateResponseMixin, ContextMixin, GenericAPIView):
    def get(self, request, *args, **kwargs):
        context = self.get_context_data(**kwargs)
        return self.render_to_response(context)

api/app/signals/apps/api/v1/views/_base.py
"""
Viewset base classes, not to be used directly.
"""
from rest_framework.viewsets import GenericViewSet

from signals.apps.signals.models import Signal


class PublicSignalGenericViewSet(GenericViewSet):
    lookup_field = 'signal_id'
    lookup_url_kwarg = 'signal_id'

    queryset = Signal.objects.all()

    pagination_class = None

api/app/signals/apps/api/v1/views/category_removed.py
"""
ViewSet that returns `signals.Signal` instance dropped out of a category.
"""
from datapunt_api.rest import HALPagination
from django_filters.rest_framework import DjangoFilterBackend
from rest_framework import viewsets

from signals.apps.api import mixins
from signals.apps.api.generics.permissions import SIAPermissions
from signals.apps.api.v1.filters import SignalCategoryRemovedAfterFilter
from signals.apps.api.v1.serializers import SignalIdListSerializer
from signals.apps.signals.models import Signal
from signals.auth.backend import JWTAuthBackend


class SignalCategoryRemovedAfterViewSet(viewsets.GenericViewSet, mixins.ListModelMixin):
    serializer_class = SignalIdListSerializer
    pagination_class = HALPagination

    authentication_classes = (JWTAuthBackend,)
    permission_classes = (SIAPermissions,)

    filter_backends = (DjangoFilterBackend,)
    filterset_class = SignalCategoryRemovedAfterFilter

    queryset = Signal.objects.only('id').all()

api/app/signals/apps/api/v1/views/namespace.py
from rest_framework.response import Response
from rest_framework.views import APIView


class NamespaceView(APIView):
    """
    Used for the curies namespace, at this moment it is just a dummy landing page so that we have
    a valid URI that resolves

    TODO: Implement HAL standard for curies in the future
    """

    def get(self, request):
        return Response()

api/app/signals/apps/api/templates/api/pdf/extra_properties.html
{% load extra_properties_tags %}

{% if signal.extra_properties %}
    <h2>Extra eigenschappen</h2>

    <table class="table" style="page-break-after: avoid; page-break-before: avoid; -pdf-page-break: avoid; margin: 30px 0 30px 0;">
    {% for extra_property in signal.extra_properties %}
        <tr>
            <td style="width: 200px;">{{ extra_property.label }}</td>
            {% if extra_property.answer|is_a_list %}
                <td>:&nbsp;
                {% for answer in extra_property.answer %}
                    {% firstof answer.label answer.value answer.answer answer '-' %}{% if not forloop.last %},&nbsp;{% endif %}
                {% endfor %}
                </td>
            {% else %}
            <td>:&nbsp;{% firstof extra_property.answer.label extra_property.answer.value extra_property.answer.answer extra_property.answer '-' %}</td>
            {% endif %}
        </tr>
    {%  endfor %}
    </table>
{% endif %}

api/app/signals/apps/api/templates/api/pdf/print_signal.html
<!DOCTYPE html>
<html>
<head lang="en">
    <meta charset="UTF-8">
    <title>Melding {{ signal.sia_id }} </title>
    <style type="text/css">
        * {
            font-family: Avenir Next LT W01 Demi,arial,sans-serif;
            font-weight: normal;
            font-size: 14px;
        }

        .divider {
            border-bottom: 1px #000 solid;
            width: 100%;
            height: 1px;
        }

        .header {
            width: 100%;
            top: 0;
            margin: 0;
            font-size: 0.8em;
        }

        .header p {
            text-align: right;
            color: #5B6270;
        }

        .header p span{
            color: #5B6270;
        }

        .results {
            border-collapse: collapse;
        }

        .results td {
            vertical-align: top;
            padding: 6px 2px;
            word-wrap: break-word;
            overflow-wrap: break-word;
        }

        .history .description {
            margin-top: 15px;
            font-style: italic;
        }

        .history .changed {
            color: gray;
        }

        .history .divider {
            margin-top: 15px;
        }

        h1 {
            color: #000;
            font-size: 1.6em;
            font-weight: bold;
        }

        h2 {
            color: #000;
            font-size: 1.2em;
            font-weight: bold;
        }

        table {
            max-width: 100%;
        }

        @page {
            size: A4;
            margin: 1.27cm;
        }
    </style>
</head>
<body>
    <div id="header_content">
        <table class="header" width="100%">
            <tr>
                <td width="40%">
                  <p style="text-align: left;">
                    <span>Geprint door {% if not user.is_anonymous %}{{ user.username }}{% else %}SIA Systeem{% endif %}</span>
                  </p>
                </td>
                <td width="60%">
                    <p>
                        <span>{% now "l, j F Y H:i" %}</span>
                    </p>
                </td>
            </tr>
        </table>
    </div>

    <div class="divider">&nbsp;</div>
    <h1>{{ signal.sia_id }}</h1>
    <div style="width: 680px; height: 250px; background-color: lightgray; margin-bottom: 25px; ">
        <img src="https://map.data.amsterdam.nl/dist/images/svg/marker.svg" alt="marker" tabindex="0" style="position: absolute; left: 320px; top: 220px; width: 40px; height: 40px;">
        <img src="https://map.data.amsterdam.nl/maps/topografie?request=GetMap&format=image%2Fpng&version=1.1.1&layers=basiskaart&srs=EPSG%3A28992&width=680&height=250&bbox={{ bbox }}" />
    </div>

    <h2>Melding</h2>
    <table class="results" style="page-break-after: always; page-break-before: avoid; -pdf-page-break: avoid; margin: 30px 0 30px 0;">
        {% if signal.is_child %}
        <tr>
            <td>Hoofdmelding</td>
            <td>: SIA-{{ signal.parent.id }}</td>
        </tr>
        {% endif %}
        <tr>
            <td style="width: 200px;">Toelichting</td>
            <td>: {{ signal.text }}</td>
        </tr>
        <tr>
            <td>Overlast</td>
            <td>: {{ signal.incident_date_start|date:"d-m-Y" }} {{ signal.incident_date_start|date:"H:i" }}</td>
        </tr>
        <tr>
            <td>Stadsdeel</td>
            <td>: {{ signal.location.get_stadsdeel_display }}</td>
        </tr>
        <tr>
            <td>Adres</td>
            <td>: {{ signal.location.address_text }}</td>
        </tr>
        <tr>
            <td>Gemeld op</td>
            <td>: {{ signal.created_at|date:"d-m-Y" }} {{ signal.created_at|date:"H:i" }}</td>
        </tr>
        <tr>
            <td>Hoofdcategorie</td>
            <td>: {{ signal.category_assignment.category.parent.name }}</td>
        </tr>
        <tr>
            <td>Subcategorie</td>
            <td>: {{ signal.category_assignment.category.name }}</td>
        </tr>
        <tr>
            <td>Urgentie</td>
            <td>: {{ signal.priority.get_priority_display }}</td>
        </tr>
        <tr>
            <td>Bron</td>
            <td>: {{ signal.source }}</td>
        </tr>
    </table>

    {% include 'api/pdf/extra_properties.html' with signal=signal %}

    <div class="divider">&nbsp;</div>
    <h2>Melder</h2>
    <table class="results" style="page-break-after: avoid; page-break-before: avoid; -pdf-page-break: avoid; margin: 30px 0 30px 0;">
        <tr>
            <td style="width: 200px;">E-mail</td>
            <td>: {{ signal.reporter.email|default:"Onbekend" }}</td>
        </tr>
        <tr>
            <td>Telefoonnummer</td>
            <td>: {{ signal.reporter.phone|default:"Onbekend" }}</td>
        </tr>
    </table>

    <div class="divider">&nbsp;</div>
    <h2>Foto's</h2>
    {% if images %}
        {% for image in images %}
            <p><img src="{{ image.file.url }}" style="width:680px" alt=""></p>
        {% endfor %}
        <br>
    {% elif jpg_data_urls %}  {# HOTFIX SIG-1473 #}
        {% for data_url in jpg_data_urls %}
            {% if data_url %}
                <p><img src="{{ data_url|safe }}" style="width:680px" alt=""></p>
            {% else %}
                <p>Image not available</p>
            {% endif %}
        {% endfor %}
        <br>
    {% else %}
        <p>Er zijn geen foto's beschikbaar omdat de melder in SIA geen foto's heeft meegeleverd.</p>
    {% endif %}

    <div class="divider">&nbsp;</div>
    <h2>Geschiedenis</h2>
    {% for history in signal.history.all %}
    <table class="history" style="page-break-after: avoid; page-break-before: avoid; -pdf-page-break: avoid; margin: 30px 0 30px 0;">
        <tr>
            <td class="changed" style="width: 200px; vertical-align:top; overflow-wrap: break-word;">Gewijzigd op {{ history.when|date:"d-m-Y" }} om {{ history.when|date:"H:i:s" }} door {{ history.who|default:"SIA systeem" }}</td>
            <td class="title" style="vertical-align:top">
                {{ history.get_action }}<br>
                {% if history.get_description %}
                    "{{ history.get_description }}"
                {% endif %}
            </td>
        </tr>
    </table>
    {% endfor %}

</body>
</html>